<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/Settings/include/Settings/SettingsManager.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_8ae0dd75af039a94f4269584fb8eef13.html">Settings</a></li><li class="navelem"><a class="el" href="dir_432cbbb5245314b613ff1e5a0d6316fd.html">include</a></li><li class="navelem"><a class="el" href="dir_5ad71ff850730ae2a3f8f6d36f5ecd38.html">Settings</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">SettingsManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_settings_manager_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_SETTINGS_INCLUDE_SETTINGS_SETTINGSMANAGER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_SETTINGS_INCLUDE_SETTINGS_SETTINGSMANAGER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;cstddef&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;utility&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_log_entry_8h.html">AVSCommon/Utils/Logger/LogEntry.h</a>&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_logger_utils_8h.html">AVSCommon/Utils/Logger/LoggerUtils.h</a>&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_setting_interface_8h.html">SettingInterface.h</a>&quot;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">namespace </span>settings {</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span>... SettingsT&gt;</div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html">   36</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html">SettingsManager</a> {</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#aa7a89f716b020c67266337681fe652bd">   50</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#aa7a89f716b020c67266337681fe652bd">SettingType</a> = <span class="keyword">typename</span> std::decay&lt;decltype(*std::get&lt;index&gt;(std::tuple&lt;SettingsT*...&gt;()))&gt;::type;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#ab871967b51878049f2257dcabd0ff4c6">   54</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#ab871967b51878049f2257dcabd0ff4c6">ValueType</a> = <span class="keyword">typename</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#aa7a89f716b020c67266337681fe652bd">SettingType&lt;index&gt;::ValueType</a>;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#acce7b56dd8ae144d8e13a481f2125440">   58</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#acce7b56dd8ae144d8e13a481f2125440">ObserverType</a> = <span class="keyword">typename</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#aa7a89f716b020c67266337681fe652bd">SettingType&lt;index&gt;::ObserverType</a>;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> SettingT&gt;</div><div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#af6a131db1743509c593152703cdf32dd">   62</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#af6a131db1743509c593152703cdf32dd">SettingPointerType</a> = std::shared_ptr&lt;SettingT&gt;;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#aac787ca8e312004eb606c362ce6cce57">SettingsManager</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a1eaf869a451665a06d0b25da6f52302f">~SettingsManager</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <a class="code" href="_set_setting_result_8h.html#a15f12c618d4b135e4f8eb35afe8a2ac5">SetSettingResult</a> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a08f496cd9a1074222872c294615a7364">setValue</a>(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#ab871967b51878049f2257dcabd0ff4c6">ValueType&lt;index&gt;</a>&amp; value);</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    std::pair&lt;bool, ValueType&lt;index&gt;&gt; <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a2703844cd7fbc775ce47c14b215ae7b4">getValue</a>(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#ab871967b51878049f2257dcabd0ff4c6">ValueType&lt;index&gt;</a>&amp; defaultValue) <span class="keyword">const</span>;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a4b5f4148b96beb370c986387cd56d20b">addObserver</a>(std::shared_ptr&lt;<a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#acce7b56dd8ae144d8e13a481f2125440">ObserverType&lt;index&gt;</a>&gt; observer);</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a966496ddce73854b17f0933316be7c03">removeObserver</a>(std::shared_ptr&lt;<a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#acce7b56dd8ae144d8e13a481f2125440">ObserverType&lt;index&gt;</a>&gt; observer);</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a3a5d3220939bcf5eb1c6bba4cebdd1fd">addSetting</a>(std::shared_ptr&lt;<a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#aa7a89f716b020c67266337681fe652bd">SettingType&lt;index&gt;</a>&gt; setting);</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a677d8b6bd86ee15fa66bb8f914d1a3ae">removeSetting</a>(std::shared_ptr&lt;<a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#aa7a89f716b020c67266337681fe652bd">SettingType&lt;index&gt;</a>&gt; setting);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">LogEntry</a> = <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">avsCommon::utils::logger::LogEntry</a>;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#aac787ca8e312004eb606c362ce6cce57">SettingsManager</a>(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html">SettingsManager</a>&amp;) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html">SettingsManager</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html">SettingsManager</a>&amp;) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <span class="keyword">mutable</span> std::mutex m_mutex;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <span class="comment">// A tuple with all the settings supported by this manager.</span></div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    std::tuple&lt;SettingPointerType&lt;SettingsT&gt;...&gt; m_settings;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;};</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span>... SettingsT&gt;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;<span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;std::pair&lt;bool, <span class="keyword">typename</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html">SettingsManager</a>&lt;SettingsT...&gt;::template ValueType&lt;index&gt;&gt; <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html">SettingsManager</a>&lt;</div><div class="line"><a name="l00157"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#ae4c48aac8419c1d4de35b628406dcf05">  157</a></span>&#160;    SettingsT...&gt;::getValue(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#ab871967b51878049f2257dcabd0ff4c6">ValueType&lt;index&gt;</a>&amp; defaultValue)<span class="keyword"> const </span>{</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    std::lock_guard&lt;std::mutex&gt; lock{m_mutex};</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <span class="keyword">auto</span>&amp; setting = std::get&lt;index&gt;(m_settings);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    <span class="keywordflow">if</span> (setting) {</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        <span class="keywordflow">return</span> {<span class="keyword">true</span>, setting-&gt;get()};</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    }</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger.html#a2a506c9c75542fad6d29643e3e3cf55d">avsCommon::utils::logger::acsdkError</a>(</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">LogEntry</a>(<span class="stringliteral">&quot;SettingManager&quot;</span>, <span class="stringliteral">&quot;getValueFailed&quot;</span>).d(<span class="stringliteral">&quot;reason&quot;</span>, <span class="stringliteral">&quot;invalidSetting&quot;</span>).d(<span class="stringliteral">&quot;settingIndex&quot;</span>, <a class="code" href="namespacealexa_client_s_d_k_1_1media_player_1_1android_1_1test.html#a7b86e4ce414fe200671d6b2f13f570a7">index</a>));</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="keywordflow">return</span> {<span class="keyword">false</span>, defaultValue};</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;}</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span>... SettingsT&gt;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00171"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a08f496cd9a1074222872c294615a7364">  171</a></span>&#160;<a class="code" href="_set_setting_result_8h.html#a15f12c618d4b135e4f8eb35afe8a2ac5">SetSettingResult</a> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a08f496cd9a1074222872c294615a7364">SettingsManager&lt;SettingsT...&gt;::setValue</a>(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#ab871967b51878049f2257dcabd0ff4c6">ValueType&lt;index&gt;</a>&amp; value) {</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    std::lock_guard&lt;std::mutex&gt; lock{m_mutex};</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keyword">auto</span>&amp; setting = std::get&lt;index&gt;(m_settings);</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    <span class="keywordflow">if</span> (setting) {</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="keywordflow">return</span> setting-&gt;setLocalChange(value);</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    }</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger.html#a2a506c9c75542fad6d29643e3e3cf55d">avsCommon::utils::logger::acsdkError</a>(</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">LogEntry</a>(<span class="stringliteral">&quot;SettingManager&quot;</span>, <span class="stringliteral">&quot;setValueFailed&quot;</span>).d(<span class="stringliteral">&quot;reason&quot;</span>, <span class="stringliteral">&quot;invalidSetting&quot;</span>).d(<span class="stringliteral">&quot;settingIndex&quot;</span>, <a class="code" href="namespacealexa_client_s_d_k_1_1media_player_1_1android_1_1test.html#a7b86e4ce414fe200671d6b2f13f570a7">index</a>));</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="_set_setting_result_8h.html#a15f12c618d4b135e4f8eb35afe8a2ac5a7fb8945c24da1480ac642eda51db249c">SetSettingResult::UNAVAILABLE_SETTING</a>;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;}</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span>... SettingsT&gt;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;<span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00185"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a4b5f4148b96beb370c986387cd56d20b">  185</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a4b5f4148b96beb370c986387cd56d20b">SettingsManager&lt;SettingsT...&gt;::addObserver</a>(std::shared_ptr&lt;<a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#acce7b56dd8ae144d8e13a481f2125440">ObserverType&lt;index&gt;</a>&gt; observer) {</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    std::lock_guard&lt;std::mutex&gt; lock{m_mutex};</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <span class="keyword">auto</span>&amp; setting = std::get&lt;index&gt;(m_settings);</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    <span class="keywordflow">if</span> (setting &amp;&amp; observer) {</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="keywordflow">return</span> setting-&gt;addObserver(observer);</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    }</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger.html#a2a506c9c75542fad6d29643e3e3cf55d">avsCommon::utils::logger::acsdkError</a>(</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">LogEntry</a>(<span class="stringliteral">&quot;SettingManager&quot;</span>, <span class="stringliteral">&quot;addObserverFailed&quot;</span>).d(<span class="stringliteral">&quot;reason&quot;</span>, <span class="stringliteral">&quot;invalidSetting&quot;</span>).d(<span class="stringliteral">&quot;settingIndex&quot;</span>, <a class="code" href="namespacealexa_client_s_d_k_1_1media_player_1_1android_1_1test.html#a7b86e4ce414fe200671d6b2f13f570a7">index</a>));</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;}</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span>... SettingsT&gt;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00199"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a966496ddce73854b17f0933316be7c03">  199</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a966496ddce73854b17f0933316be7c03">SettingsManager&lt;SettingsT...&gt;::removeObserver</a>(std::shared_ptr&lt;<a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#acce7b56dd8ae144d8e13a481f2125440">ObserverType&lt;index&gt;</a>&gt; observer) {</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    std::lock_guard&lt;std::mutex&gt; lock{m_mutex};</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    <span class="keyword">auto</span>&amp; setting = std::get&lt;index&gt;(m_settings);</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <span class="keywordflow">if</span> (setting &amp;&amp; observer) {</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        setting-&gt;removeObserver(observer);</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    }</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger.html#a2a506c9c75542fad6d29643e3e3cf55d">avsCommon::utils::logger::acsdkError</a>(</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">LogEntry</a>(<span class="stringliteral">&quot;SettingManager&quot;</span>, <span class="stringliteral">&quot;removeObserverFailed&quot;</span>).d(<span class="stringliteral">&quot;reason&quot;</span>, <span class="stringliteral">&quot;invalidSetting&quot;</span>).d(<span class="stringliteral">&quot;settingIndex&quot;</span>, <a class="code" href="namespacealexa_client_s_d_k_1_1media_player_1_1android_1_1test.html#a7b86e4ce414fe200671d6b2f13f570a7">index</a>));</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;}</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span>... SettingsT&gt;</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;<span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00212"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a3a5d3220939bcf5eb1c6bba4cebdd1fd">  212</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a3a5d3220939bcf5eb1c6bba4cebdd1fd">SettingsManager&lt;SettingsT...&gt;::addSetting</a>(std::shared_ptr&lt;<a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#aa7a89f716b020c67266337681fe652bd">SettingType&lt;index&gt;</a>&gt; newSetting) {</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    std::lock_guard&lt;std::mutex&gt; lock{m_mutex};</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    <span class="keyword">auto</span>&amp; setting = std::get&lt;index&gt;(m_settings);</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    <span class="keywordflow">if</span> (!setting &amp;&amp; newSetting) {</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        setting.swap(newSetting);</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    }</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger.html#a2a506c9c75542fad6d29643e3e3cf55d">avsCommon::utils::logger::acsdkError</a>(</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">LogEntry</a>(<span class="stringliteral">&quot;SettingManager&quot;</span>, <span class="stringliteral">&quot;addSettingFailed&quot;</span>).d(<span class="stringliteral">&quot;reason&quot;</span>, <span class="stringliteral">&quot;invalidSetting&quot;</span>).d(<span class="stringliteral">&quot;settingIndex&quot;</span>, <a class="code" href="namespacealexa_client_s_d_k_1_1media_player_1_1android_1_1test.html#a7b86e4ce414fe200671d6b2f13f570a7">index</a>));</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;}</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span>... SettingsT&gt;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;<span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> index&gt;</div><div class="line"><a name="l00227"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a677d8b6bd86ee15fa66bb8f914d1a3ae">  227</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a677d8b6bd86ee15fa66bb8f914d1a3ae">SettingsManager&lt;SettingsT...&gt;::removeSetting</a>(std::shared_ptr&lt;<a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#aa7a89f716b020c67266337681fe652bd">SettingType&lt;index&gt;</a>&gt; oldSetting) {</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    std::lock_guard&lt;std::mutex&gt; lock{m_mutex};</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    <span class="keyword">auto</span>&amp; setting = std::get&lt;index&gt;(m_settings);</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <span class="keywordflow">if</span> (setting == oldSetting) {</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        setting.reset();</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger.html#a2a506c9c75542fad6d29643e3e3cf55d">avsCommon::utils::logger::acsdkError</a>(</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;            <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">LogEntry</a>(<span class="stringliteral">&quot;SettingManager&quot;</span>, <span class="stringliteral">&quot;removeSettingFailed&quot;</span>).d(<span class="stringliteral">&quot;reason&quot;</span>, <span class="stringliteral">&quot;invalidSetting&quot;</span>).d(<span class="stringliteral">&quot;settingIndex&quot;</span>, <a class="code" href="namespacealexa_client_s_d_k_1_1media_player_1_1android_1_1test.html#a7b86e4ce414fe200671d6b2f13f570a7">index</a>));</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    }</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;}</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;}  <span class="comment">// namespace settings</span></div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_SETTINGS_INCLUDE_SETTINGS_SETTINGSMANAGER_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html">alexaClientSDK::settings::SettingsManager</a></div><div class="ttdef"><b>Definition:</b> SettingsManager.h:36</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html_a3a5d3220939bcf5eb1c6bba4cebdd1fd"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a3a5d3220939bcf5eb1c6bba4cebdd1fd">alexaClientSDK::settings::SettingsManager::addSetting</a></div><div class="ttdeci">bool addSetting(std::shared_ptr&lt; SettingType&lt; index &gt;&gt; setting)</div><div class="ttdef"><b>Definition:</b> SettingsManager.h:212</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html_acce7b56dd8ae144d8e13a481f2125440"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#acce7b56dd8ae144d8e13a481f2125440">alexaClientSDK::settings::SettingsManager&lt; alexaClientSDK::settings::test::SettingStub, alexaClientSDK::settings::test::SettingStub &gt;::ObserverType</a></div><div class="ttdeci">typename SettingType&lt; index &gt;::ObserverType ObserverType</div><div class="ttdoc">Define the observer type for setting kept on position index. </div><div class="ttdef"><b>Definition:</b> SettingsManager.h:58</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html_a2703844cd7fbc775ce47c14b215ae7b4"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a2703844cd7fbc775ce47c14b215ae7b4">alexaClientSDK::settings::SettingsManager::getValue</a></div><div class="ttdeci">std::pair&lt; bool, ValueType&lt; index &gt; &gt; getValue(const ValueType&lt; index &gt; &amp;defaultValue) const</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html_af6a131db1743509c593152703cdf32dd"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#af6a131db1743509c593152703cdf32dd">alexaClientSDK::settings::SettingsManager&lt; alexaClientSDK::settings::test::SettingStub, alexaClientSDK::settings::test::SettingStub &gt;::SettingPointerType</a></div><div class="ttdeci">std::shared_ptr&lt; SettingT &gt; SettingPointerType</div><div class="ttdoc">Define the shared_ptr type for the given SettingT. </div><div class="ttdef"><b>Definition:</b> SettingsManager.h:62</div></div>
<div class="ttc" id="_logger_utils_8h_html"><div class="ttname"><a href="_logger_utils_8h.html">LoggerUtils.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html_ab871967b51878049f2257dcabd0ff4c6"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#ab871967b51878049f2257dcabd0ff4c6">alexaClientSDK::settings::SettingsManager&lt; alexaClientSDK::settings::test::SettingStub, alexaClientSDK::settings::test::SettingStub &gt;::ValueType</a></div><div class="ttdeci">typename SettingType&lt; index &gt;::ValueType ValueType</div><div class="ttdoc">Define the value type for setting kept on position index. </div><div class="ttdef"><b>Definition:</b> SettingsManager.h:54</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1media_player_1_1android_1_1test_html_a7b86e4ce414fe200671d6b2f13f570a7"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1media_player_1_1android_1_1test.html#a7b86e4ce414fe200671d6b2f13f570a7">alexaClientSDK::mediaPlayer::android::test::index</a></div><div class="ttdeci">static int index</div><div class="ttdoc">Mock buffer index. </div><div class="ttdef"><b>Definition:</b> AndroidSLESMediaQueueTest.cpp:70</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html_aac787ca8e312004eb606c362ce6cce57"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#aac787ca8e312004eb606c362ce6cce57">alexaClientSDK::settings::SettingsManager::SettingsManager</a></div><div class="ttdeci">SettingsManager()=default</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html_a1eaf869a451665a06d0b25da6f52302f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a1eaf869a451665a06d0b25da6f52302f">alexaClientSDK::settings::SettingsManager::~SettingsManager</a></div><div class="ttdeci">virtual ~SettingsManager()=default</div></div>
<div class="ttc" id="_set_setting_result_8h_html_a15f12c618d4b135e4f8eb35afe8a2ac5a7fb8945c24da1480ac642eda51db249c"><div class="ttname"><a href="_set_setting_result_8h.html#a15f12c618d4b135e4f8eb35afe8a2ac5a7fb8945c24da1480ac642eda51db249c">SetSettingResult::UNAVAILABLE_SETTING</a></div><div class="ttdoc">The request was failed because the setting requested does not exist. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html_a4b5f4148b96beb370c986387cd56d20b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a4b5f4148b96beb370c986387cd56d20b">alexaClientSDK::settings::SettingsManager::addObserver</a></div><div class="ttdeci">bool addObserver(std::shared_ptr&lt; ObserverType&lt; index &gt;&gt; observer)</div><div class="ttdef"><b>Definition:</b> SettingsManager.h:185</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html_a677d8b6bd86ee15fa66bb8f914d1a3ae"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a677d8b6bd86ee15fa66bb8f914d1a3ae">alexaClientSDK::settings::SettingsManager::removeSetting</a></div><div class="ttdeci">void removeSetting(std::shared_ptr&lt; SettingType&lt; index &gt;&gt; setting)</div><div class="ttdef"><b>Definition:</b> SettingsManager.h:227</div></div>
<div class="ttc" id="_log_entry_8h_html"><div class="ttname"><a href="_log_entry_8h.html">LogEntry.h</a></div></div>
<div class="ttc" id="_set_setting_result_8h_html_a15f12c618d4b135e4f8eb35afe8a2ac5"><div class="ttname"><a href="_set_setting_result_8h.html#a15f12c618d4b135e4f8eb35afe8a2ac5">SetSettingResult</a></div><div class="ttdeci">SetSettingResult</div><div class="ttdef"><b>Definition:</b> SetSettingResult.h:21</div></div>
<div class="ttc" id="_setting_interface_8h_html"><div class="ttname"><a href="_setting_interface_8h.html">SettingInterface.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html_aa7a89f716b020c67266337681fe652bd"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#aa7a89f716b020c67266337681fe652bd">alexaClientSDK::settings::SettingsManager&lt; alexaClientSDK::settings::test::SettingStub, alexaClientSDK::settings::test::SettingStub &gt;::SettingType</a></div><div class="ttdeci">typename std::decay&lt; decltype(*std::get&lt; index &gt;(std::tuple&lt; SettingsT *... &gt;()))&gt;::type SettingType</div><div class="ttdef"><b>Definition:</b> SettingsManager.h:50</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html_a08f496cd9a1074222872c294615a7364"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a08f496cd9a1074222872c294615a7364">alexaClientSDK::settings::SettingsManager::setValue</a></div><div class="ttdeci">SetSettingResult setValue(const ValueType&lt; index &gt; &amp;value)</div><div class="ttdef"><b>Definition:</b> SettingsManager.h:171</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_settings_manager_html_a966496ddce73854b17f0933316be7c03"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_settings_manager.html#a966496ddce73854b17f0933316be7c03">alexaClientSDK::settings::SettingsManager::removeObserver</a></div><div class="ttdeci">void removeObserver(std::shared_ptr&lt; ObserverType&lt; index &gt;&gt; observer)</div><div class="ttdef"><b>Definition:</b> SettingsManager.h:199</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_html_a2a506c9c75542fad6d29643e3e3cf55d"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger.html#a2a506c9c75542fad6d29643e3e3cf55d">alexaClientSDK::avsCommon::utils::logger::acsdkError</a></div><div class="ttdeci">void acsdkError(const LogEntry &amp;entry)</div><div class="ttdef"><b>Definition:</b> LoggerUtils.cpp:80</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a></div><div class="ttdoc">LogEntry is used to compile the log entry text to log via Logger. </div><div class="ttdef"><b>Definition:</b> LogEntry.h:30</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
